<?php

	class widgetHoroscopes extends cmsWidget{

		private $db;
		public $is_cacheable = false;

		public function __construct($widget){
			parent::__construct($widget);
			$this->db = cmsCore::getInstance()->db;
		}

		public function run(){

			$root     = cmsConfig::getInstance()->root;
			$user     = cmsUser::getInstance();
			$template = cmsTemplate::getInstance();
			
			$template->addCSS('templates/default/widgets/horoscopes/css/style.css');
			$template->addJS('templates/default/widgets/horoscopes/js/script.js');
			
			// Зодиак. Числовым индексам соответствует поле базы "zodiac"
			$zodiac = array('Овен', 'Телец', 'Близнецы', 'Рак', 'Лев', 'Дева', 'Весы', 'Скорпион', 'Стрелец', 'Козерог', 'Водолей', 'Рыбы');
			// Гороскопы. Индекс соответствует столбцу "category_id"
			$cat_id = array(1=>'Общий гороскоп', 2=>'Любовный гороскоп', 3=>'Эротический гороскоп', 4=>'Антигороскоп', 5=>'Бизнес-гороскоп', 6=>'Кулинарный гороскоп', 7=>'Гороскоп здоровья');
			$index  = 0;
			$avatar = $root.'upload/default/avatar_small.jpg';
			
			// Корректируем индекс и аватар если пользователь авторизован
			if($user->id){
				$t = explode(' ', $user->birth_date);
				$t = explode('-', $t[0]);
				$m = (int)$t[1];
				$d = (int)$t[2];
				if($d * $m){// Если не ноль
					if(($m==1 && $d>20) || ($m==2 && $d<19)){ $index = 10; }
					elseif(($m==2  && $d>18) || ($m==3  && $d<21)){ $index = 11; }
					elseif(($m==3  && $d>20) || ($m==4  && $d<21)){ $index = 0; }
					elseif(($m==4  && $d>20) || ($m==5  && $d<22)){ $index = 1; }
					elseif(($m==5  && $d>21) || ($m==6  && $d<22)){ $index = 2; }
					elseif(($m==6  && $d>21) || ($m==7  && $d<23)){ $index = 3; }
					elseif(($m==7  && $d>22) || ($m==8  && $d<24)){ $index = 4; }
					elseif(($m==8  && $d>23) || ($m==9  && $d<24)){ $index = 5; }
					elseif(($m==9  && $d>23) || ($m==10 && $d<24)){ $index = 6; }
					elseif(($m==10 && $d>23) || ($m==11 && $d<23)){ $index = 7; }
					elseif(($m==11 && $d>22) || ($m==12 && $d<22)){ $index = 8; }
					elseif(($m==12 && $d>21) || ($m==1  && $d<21)){ $index = 9; }
				}
				if(!empty($user->avatar['small'])){ $avatar = $user->avatar['small']; }
			}

			// Перехватываем индекс зодиака
			if(isset($_POST['cur_index'])){ $index = (int)$_POST['cur_index']; }

			// Перехватываем целевой день
			$on_day = isset($_POST['on_day']) ? $_POST['on_day'] : 'today';
			switch($on_day){
				case 'yesterday':
						$on_date = 'CURDATE() - INTERVAL 1 DAY';
						$this->title = $zodiac[$index].' - гороскоп на вчера';
						break;
				case 'tomorrow':
						$on_date = 'CURDATE() + INTERVAL 1 DAY';
						$this->title = $zodiac[$index].' - гороскоп на завтра';
						break;
				default:
						$on_date = 'CURDATE()';
						$this->title = $zodiac[$index].' - гороскоп на сегодня';
			}

			// Гороскопы на указанный день для указанного знака зодиака
			$sql = "SELECT category_id AS cat_id, description FROM {#}horoscopes WHERE zodiac = {$index} AND cdate = {$on_date} ORDER BY category_id LIMIT 7";
			
			$result = $this->db->query($sql);

			// Если результат нулевой, значит нужно обновить базу
			if(!$this->db->numRows($result)){
				$this->load_horoscopes();
				$result = $this->db->query($sql);
			}
			
			if(!$this->db->numRows($result)){ return false; }

			$items = array();
			while($item = $this->db->fetchAssoc($result)){
				$item['horoscop'] = $cat_id[$item['cat_id']];
				$items[] = $item;
			}

			// Проверяю наличие куки и загоняю в переменную значение
			$tab_index = isset($_COOKIE['horo_tab_index']) ? (int)$_COOKIE['horo_tab_index'] : false;

			return array(
				'zodiac'    => $zodiac,     // Массив знаков зодиака для меню
				'items'     => $items,      // Массив гороскопов и данные для построения меню гороскопов
				'cur_index' => $index,      // Индекс текущего знака зодиака
				'tab_index' => $tab_index,  // Индекс текущей вкладки
				'on_day'    => $on_day,     // Целевой день
				'avatar'    => $avatar,     // Путь к файлу аватара
				'title'     => $this->title,// Заголовок модуля
				'root'      => $root        // Корень сайта
			);

		}

		private function load_horoscopes(){

			// Чтобы не накапливать мусор
			$this->db->query("TRUNCATE TABLE {#}horoscopes");

			// Адреса xml файлов с гороскопами
			$sources = array(
				1 => 'http://img.ignio.com/r/export/win/xml/daily/com.xml',  // Общий гороскоп
				2 => 'http://img.ignio.com/r/export/win/xml/daily/lov.xml',  // Любовный гороскоп
				3 => 'http://img.ignio.com/r/export/win/xml/daily/ero.xml',  // Эротический гороскоп
				4 => 'http://img.ignio.com/r/export/win/xml/daily/anti.xml', // Антигороскоп
				5 => 'http://img.ignio.com/r/export/win/xml/daily/bus.xml',  // Бизнес-гороскоп
				6 => 'http://img.ignio.com/r/export/win/xml/daily/cook.xml', // Кулинарный гороскоп
				7 => 'http://img.ignio.com/r/export/win/xml/daily/hea.xml',  // Гороскоп здоровья
			);
			
			foreach($sources as $id=>$url){
				$this->get_horoscopes($url, $id);
			}

			return true;
		}

		// Загружает и разбирает xml 
		private function get_horoscopes($url, $id){
			$xml_contents = file_get_contents($url);
			if(!$xml_contents) return false;// Если xml вообще не получен
			$xml = new SimpleXMLElement($xml_contents);
			$xml_obj = $xml->xpath('/horo/date');
			if(!$xml_obj) return false;// Если xml пустой
			$xml_attr = $xml_obj[0];
			$date = array();
			$date[0] = $xml_attr['yesterday'];
			$date[1] = $xml_attr['today'];
			$date[2] = $xml_attr['tomorrow'];
			$date[3] = $xml_attr['tomorrow02'];
			$zodiac = array('aries', 'taurus', 'gemini', 'cancer', 'leo', 'virgo', 'libra', 'scorpio', 'sagittarius', 'capricorn', 'aquarius', 'pisces');

			// Получаем гороскоп на 4 дня для каждого знака зодиака
			foreach($zodiac as $k=>$v){
				$xml_obj = $xml->xpath('/horo/'.$v);
				if(!$xml_obj) continue;
				$xml_attr = $xml_obj[0];
				$this->update_horoscopes($date[0], $k, ($xml_attr->yesterday), $id);
				$this->update_horoscopes($date[1], $k, ($xml_attr->today), $id);
				$this->update_horoscopes($date[2], $k, ($xml_attr->tomorrow), $id);
				$this->update_horoscopes($date[3], $k, ($xml_attr->tomorrow02), $id);
			}

			return true;
		}

		// Обновляет запись в базе
		private function update_horoscopes($date, $zodiac, $description, $cat_id){
			// Приводим загруженную дату гороскопа в формат БД
			list($d, $m, $y) = explode('.', $date);
			$date = $y.'-'.$m.'-'.$d;
			// На всякий случай фильтруем текст
			$description = strip_tags($description);
			$description = $this->db->escape($description);
			// Запись
			$this->db->query("INSERT INTO {#}horoscopes(cdate, zodiac, description, category_id) VALUES('{$date}', {$zodiac}, '{$description}', {$cat_id})");

			return true;
		}

	}
